#define RGB     	1
#define XYZ     	2
#define LUV     	3
#define LAB     	4
#define RLAB     	5
#define SLAB     	6
#define LHS    		7

#define RMAX		255.000 
#define RMIN		0.000
#define GMAX		255.000 
#define GMIN		0.000
#define BMAX		255.000 
#define BMIN		0.000

#define XMAX		Xn
#define XMIN		0.000
#define YMAX		Yn
#define YMIN		0.000
#define ZMAX		Zn
#define ZMIN		0.000

#define LstarMAX	100.000 
#define LstarMIN	0.000

#define UstarMAX	175.010
#define UstarMIN	(-83.086)
#define VstarMAX	107.397
#define VstarMIN	(-134.099)

#define AstarMAX	98.229 
#define AstarMIN	(-86.187)
#define BstarMAX	94.477
#define BstarMIN	(-107.859)

#define	HueMAX		3.142
#define	HueMIN		(-3.142)
#define	SatMAX		4.046
#define	SatMIN		(0.000)

#define	YyMAX		116.000
#define	YyMIN		0.000
#define	CxMAX		169.456
#define	CxMIN		(-169.479)
#define	CzMAX		160.120
#define	CzMIN		(-160.112)


float engamma(float lvalue, float gamma);
float degamma(float gvalue, float gamma);

void RGB_to_XYZ(float R, float G, float B, float *X, float *Y, float *Z);
void XYZ_to_LUV(float X, float Y, float Z, float *L, float *ustar,float *vstar);
void XYZ_to_LAB(float X, float Y, float Z, float *L, float *astar,float *bstar);
void XYZ_to_RLAB(float X, float Y, float Z, float *Lr, float *Ar, float *Br);
void XYZ_to_SLAB(float X, float Y, float Z, float *Yy, float *Cx, float *Cz);
void XYZ_to_LHS(float X, float Y, float Z, float *L, float *Hue, float *Sat);

void XYZ_to_RGB(float X, float Y, float Z, float *R, float *G, float *B);
void LUV_to_XYZ(float L, float ustar, float vstar, float *X, float *Y,float *Z);
void LAB_to_XYZ(float L, float astar, float bstar, float *X, float *Y,float *Z);
void RLAB_to_XYZ(float Lr, float Ar, float Br, float *X, float *Y, float *Z);
void SLAB_to_XYZ(float Yy, float Cx, float Cz, float *X, float *Y, float *Z);
void LHS_to_XYZ(float L, float Hue, float Sat, float *X, float *Y, float *Z);

void setwhitepoint(float R, float G, float B);
