#include "defs.h"
#include "pxm.h"
#include "tiff.h"
#include "jpeg.h"

#define		TCL_MAX			256

static int parse_tcl(char *tcl_command, int *tcl_argc, char *tcl_argv[]);

int main (int argc, char **argv)
{
  struct pxm_img pxm_img;
  struct TIFF_img tiff_img;
  struct JPEG_img jpeg_img;
  FILE   *fin;
  char   *fname, line[256];
  char   *tcl_argv[TCL_MAX];
  int    status;
  int    tcl_argc;


  status = 0;

  while (1) {

    fprintf(stdout,"Command> ");
    fflush(stdout);

    gets(line);

	parse_tcl(line, &tcl_argc, tcl_argv);

    if		  (tcl_argc == 0) {

	  fprintf(stdout, "\n");
	  fflush(stdout);

	} else if (!strncmp(tcl_argv[0], "exit", 4)) {
	  break;

    } else {

      fname = tcl_argv[0];

      if((fin=fopen(fname, "rb"))==NULL) {
        fprintf(stdout,"Error: can't read from %s\n", fname); 
  	    fflush(stdout);
        continue;
	  }

      if        (read_pxm_header (fin, &pxm_img) == 0) {

	      fprintf(stdout,"OK\n"); 
  	      fflush(stdout);

	  } else if (read_TIFF_header(fin, &tiff_img) == 0) {

	      fprintf(stdout,"OK\n"); 
  	      fflush(stdout);

	  } else if (read_JPEG_header(fin, &jpeg_img, 0) == 0) {

	      fprintf(stdout,"OK\n"); 
  	      fflush(stdout);

	  } else {
    
	      fprintf(stdout,"Error: can not recognize format of %s\n",fname); 
  	      fflush(stdout);

	  }

      fclose(fin);

	}

  }

  return(0);

}


/* Parse the relevance/irrelevance list */
static int parse_tcl(char *tcl_command, int *tcl_argc, char *tcl_argv[])
{
  char *token;
  int  i ;

  *tcl_argc = 0;
  for (i=0; i<TCL_MAX; i++) tcl_argv[i] = NULL;

  token = strtok(tcl_command, " ");
  for (i=0; i<TCL_MAX && token != NULL; i++) {
    
	if (token == NULL) return (0);
	tcl_argv[*tcl_argc] = token;
	(*tcl_argc) ++;
    token = strtok(NULL, " ");

  }
  return(0);

}


